## gbsplay 0.0.8+dfsg1

=== Makefile ===
# $Id: Makefile,v 1.98 2006/01/15 00:05:03 ranmachan Exp $

.PHONY: all default distclean clean install dist

all: default

noincludes  := $(patsubst clean,yes,$(patsubst distclean,yes,$(MAKECMDGOALS)))

prefix      := /usr/local
exec_prefix := $(prefix)

bindir      := $(exec_prefix)/bin
libdir      := $(exec_prefix)/lib
mandir      := $(prefix)/man
docdir      := $(prefix)/share/doc/gbsplay
localedir   := $(prefix)/share/locale

GBSCFLAGS  := -Wall
GBSLDFLAGS := -Wl,-O1
GBSPLAYLDFLAGS :=

ifneq ($(noincludes),yes)
-include config.mk
endif

XMMSPREFIX  :=
DESTDIR     :=

prefix      := $(DESTDIR)$(prefix)
exec_prefix := $(DESTDIR)$(exec_prefix)
bindir      := $(DESTDIR)$(bindir)
mandir      := $(DESTDIR)$(mandir)
docdir      := $(DESTDIR)$(docdir)
localedir   := $(DESTDIR)$(localedir)

xmmsdir     := $(DESTDIR)$(XMMSPREFIX)$(XMMS_INPUT_PLUGIN_DIR)

man1dir     := $(mandir)/man1
man5dir     := $(mandir)/man5
contribdir  := $(docdir)/contrib
exampledir  := $(docdir)/examples

DISTDIR := gbsplay-$(VERSION)

GBSCFLAGS  += $(EXTRA_CFLAGS)
GBSLDFLAGS += $(EXTRA_LDFLAGS)

export CC GBSCFLAGS GBSLDFLAGS

docs           := README HISTORY COPYRIGHT
contribs       := contrib/gbs2ogg.sh
examples       := examples/nightmode.gbs examples/gbsplayrc_sample

mans           := gbsplay.1    gbsinfo.1    gbsplayrc.5
mans_src       := gbsplay.in.1 gbsinfo.in.1 gbsplayrc.in.5

objs_libgbspic := gbcpu.lo gbhw.lo gbs.lo cfgparser.lo crc32.lo
objs_libgbs    := gbcpu.o  gbhw.o  gbs.o  cfgparser.o  crc32.o
objs_gbsplay   := gbsplay.o util.o plugout.o
objs_gbsinfo   := gbsinfo.o
objs_gbsxmms   := gbsxmms.lo

# gbsplay output plugins
ifeq ($(plugout_devdsp),yes)
objs_gbsplay += plugout_devdsp.o
endif
ifeq ($(plugout_nas),yes)
objs_gbsplay += plugout_nas.o
GBSPLAYLDFLAGS += -laudio $(libaudio_flags)
endif
ifeq ($(plugout_stdout),yes)
objs_gbsplay += plugout_stdout.o
endif

# Cygwin automatically adds .exe to binaries.
# We should notice that or we can't rm the files later!
gbsplaybin     := gbsplay
gbsinfobin     := gbsinfo
ifeq ($(cygwin_build),yes)
gbsplaybin     :=$(gbsplaybin).exe
gbsinfobin     :=$(gbsinfobin).exe
endif

ifeq ($(use_sharedlibgbs),yes)
GBSLDFLAGS += -L. -lgbs
EXTRA_INSTALL += install-libgbs.so.1
EXTRA_UNINSTALL += uninstall-libgbs.so.1

objs += $(objs_libgbspic)

install-libgbs.so.1:
	install -d $(libdir)
	install -m 644 libgbs.so.1 $(libdir)/libgbs.so.1

uninstall-libgbs.so.1:
	rm -f $(libdir)/libgbs.so.1
	-rmdir -p $(libdir)


libgbs.so.1: $(objs_libgbspic) libgbs.so.1.ver
	$(CC) -fpic -shared -Wl,-O1 -Wl,-soname=$@ -Wl,--version-script,$@.ver -o $@ $(objs_libgbspic)
	ln -fs $@ libgbs.so

libgbs: libgbs.so.1
	touch libgbs

libgbspic: libgbs.so.1
	touch libgbspic
else
objs += $(objs_libgbs)
objs_gbsplay += libgbs.a
objs_gbsinfo += libgbs.a
ifeq ($(build_xmmsplugin),yes)
objs += $(objs_libgbspic)
objs_gbsxmms += libgbspic.a
endif # build_xmmsplugin

libgbs: libgbs.a
	touch libgbs

libgbspic: libgbspic.a
	touch libgbspic
endif # use_sharedlibs

objs += $(objs_gbsplay) $(objs_gbsinfo)
dsts += gbsplay gbsinfo

ifeq ($(build_xmmsplugin),yes)
objs += $(objs_gbsxmms)
dsts += gbsxmms.so
endif

# include the rules for each subdir
include $(shell find . -type f -name "subdir.mk")

default: config.mk $(objs) $(dsts) $(mans) $(EXTRA_ALL) test

# include the dependency files

ifneq ($(noincludes),yes)
deps := $(patsubst %.o,%.d,$(filter %.o,$(objs)))
deps += $(patsubst %.lo,%.d,$(filter %.lo,$(objs)))
-include $(deps)
endif

distclean: clean
	find . -regex ".*\.d" -exec rm -f "{}" \;
	rm -f ./config.mk ./config.h ./config.err ./config.sed

clean:
	find . -regex ".*\.\([aos]\|lo\|mo\|pot\|so\(\.[0-9]\)?\)" -exec rm -f "{}" \;
	find . -name "*~" -exec rm -f "{}" \;
	rm -f libgbs libgbspic
	rm -f $(mans)
	rm -f $(gbsplaybin) $(gbsinfobin)

install: all install-default $(EXTRA_INSTALL)

install-default:
	install -d $(bindir)
	install -d $(man1dir)
	install -d $(man5dir)
	install -d $(docdir)
	install -d $(contribdir)
	install -d $(exampledir)
	install -m 755 $(gbsplaybin) $(gbsinfobin) $(bindir)
	install -m 644 gbsplay.1 gbsinfo.1 $(man1dir)
	install -m 644 gbsplayrc.5 $(man5dir)
	install -m 644 $(docs) $(docdir)
	install -m 644 $(contribs) $(contribdir)
	install -m 644 $(examples) $(exampledir)
	for i in $(mos); do \
		base=`basename $$i`; \
		install -d $(localedir)/$${base%.mo}/LC_MESSAGES; \
		install -m 644 $$i $(localedir)/$${base%.mo}/LC_MESSAGES/gbsplay.mo; \
	done

install-gbsxmms.so:
	install -d $(xmmsdir)
	install -m 644 gbsxmms.so $(xmmsdir)/gbsxmms.so

uninstall: uninstall-default $(EXTRA_UNINSTALL)

uninstall-default:
	rm -f $(bindir)/$(gbsplaybin) $(bindir)/$(gbsinfobin)
	-rmdir -p $(bindir)
	rm -f $(man1dir)/gbsplay.1 $(man1dir)/gbsinfo.1
	-rmdir -p $(man1dir)
	rm -f $(man5dir)/gbsplayrc.5 $(man5dir)/gbsplayrc.5	
	-rmdir -p $(man5dir)
	rm -rf $(contribdir)
	-rmdir -p $(contribdir)
	rm -rf $(exampledir)
	-rmdir -p $(exampledir)
	rm -rf $(docdir)
	-mkdir -p $(docdir)
	-rmdir -p $(docdir)
	-for i in $(mos); do \
		base=`basename $$i`; \
		rm -f $(localedir)/$${base%.mo}/LC_MESSAGES/gbsplay.mo; \
		rmdir -p $(localedir)/$${base%.mo}/LC_MESSAGES; \
	done

uninstall-gbsxmms.so:
	rm -f $(xmmsdir)/gbsxmms.so
	-rmdir -p $(xmmsdir)

dist:	distclean
	install -d ./$(DISTDIR)
	sed 's/^VERSION=.*/VERSION=$(VERSION)/' < configure > ./$(DISTDIR)/configure
	chmod 755 ./$(DISTDIR)/configure
	install -m 755 depend.sh ./$(DISTDIR)/
	install -m 644 Makefile ./$(DISTDIR)/
	install -m 644 *.c ./$(DISTDIR)/
	install -m 644 *.h ./$(DISTDIR)/
	install -m 644 *.ver ./$(DISTDIR)/
	install -m 644 $(mans_src) ./$(DISTDIR)/
	install -m 644 $(docs) INSTALL CODINGSTYLE ./$(DISTDIR)/
	install -d ./$(DISTDIR)/examples
	install -m 644 $(examples) ./$(DISTDIR)/examples
	install -d ./$(DISTDIR)/contrib
	install -m 644 $(contribs) ./$(DISTDIR)/contrib
	install -d ./$(DISTDIR)/po
	install -m 644 po/*.po ./$(DISTDIR)/po
	install -m 644 po/subdir.mk ./$(DISTDIR)/po
	tar -cvzf ../$(DISTDIR).tar.gz $(DISTDIR)/ 
	rm -rf ./$(DISTDIR)

TESTOPTS := -r 44100 -t 30 -f 0 -g 0 -T 0

test: gbsplay
	@MD5=`LD_LIBRARY_PATH=.:$$LD_LIBRARY_PATH ./gbsplay -E b -o stdout $(TESTOPTS) examples/nightmode.gbs 1 | md5sum | cut -f1 -d\ `; \
	EXPECT="3e0b21573e742101581b503da3ddf2f5"; \
	if [ "$$MD5" = "$$EXPECT" ]; then \
		echo "Bigendian output ok"; \
	else \
		echo "Bigendian output failed"; \
		echo "  Expected: $$EXPECT"; \
		echo "  Got:      $$MD5" ; \
		exit 1; \
	fi
	@MD5=`LD_LIBRARY_PATH=.:$$LD_LIBRARY_PATH ./gbsplay -E l -o stdout $(TESTOPTS) examples/nightmode.gbs 1 | md5sum | cut -f1 -d\ `; \
	EXPECT="3e540a0bddc00cb1e0b7c4bf1a3708d7"; \
	if [ "$$MD5" = "$$EXPECT" ]; then \
		echo "Littleendian output ok"; \
	else \
		echo "Littleendian output failed"; \
		echo "  Expected: $$EXPECT"; \
		echo "  Got:      $$MD5" ; \
		exit 1; \
	fi

libgbspic.a: $(objs_libgbspic)
	$(AR) r $@ $+
libgbs.a: $(objs_libgbs)
	$(AR) r $@ $+
gbsinfo: $(objs_gbsinfo) libgbs
	$(CC) -o $(gbsinfobin) $(objs_gbsinfo) $(GBSLDFLAGS)
gbsplay: $(objs_gbsplay) libgbs
	$(CC) -o $(gbsplaybin) $(objs_gbsplay) $(GBSLDFLAGS) $(GBSPLAYLDFLAGS) -lm

gbsxmms.so: $(objs_gbsxmms) libgbspic gbsxmms.so.ver
	$(CC) -shared -fpic -Wl,--version-script,$@.ver -o $@ $(objs_gbsxmms) $(GBSLDFLAGS) $(PTHREAD)

# rules for suffixes

.SUFFIXES: .i .s .lo

.c.lo:
	@echo CC $< -o $@
	@$(CC) $(GBSCFLAGS) -fpic -c -o $@ $<
.c.o:
	@echo CC $< -o $@
	@$(CC) $(GBSCFLAGS) -c -o $@ $<
.c.i:
	$(CC) -E $(GBSCFLAGS) -o $@ $<
.c.s:
	$(CC) -S $(GBSCFLAGS) -fverbose-asm -o $@ $<

# rules for generated files

config.mk: configure
	./configure

%.d: %.c config.mk
	@echo DEP $< -o $@
	@./depend.sh $< config.mk > $@ || rm -f $@

%.1: %.in.1
	sed -f config.sed $< > $@

%.5: %.in.5
	sed -f config.sed $< > $@

## gbsplay 0.0.91

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,3 @@
-# $Id: Makefile,v 1.98 2006/01/15 00:05:03 ranmachan Exp $
-
 .PHONY: all default distclean clean install dist
 
 all: default
@@ -15,8 +13,30 @@
 docdir      := $(prefix)/share/doc/gbsplay
 localedir   := $(prefix)/share/locale
 
-GBSCFLAGS  := -Wall
-GBSLDFLAGS := -Wl,-O1
+SPLINT := splint
+
+SPLINTFLAGS := \
+	+quiet \
+	-exportlocal \
+	-unrecog \
+	-immediatetrans \
+	-fullinitblock \
+	-namechecks \
+	-preproc \
+	-fcnuse \
+	-predboolint \
+	-boolops \
+	-formatconst \
+	-type \
+	+unixlib \
+	+boolint \
+	+matchanyintegral \
+	+charint \
+	-predboolothers \
+	-shiftnegative \
+	-shiftimplementation
+GBSCFLAGS  := -Wall -fsigned-char -D_FORTIFY_SOURCE=2
+GBSLDFLAGS := -Wl,-O1 -lm
 GBSPLAYLDFLAGS :=
 
 ifneq ($(noincludes),yes)
@@ -48,14 +68,14 @@
 export CC GBSCFLAGS GBSLDFLAGS
 
 docs           := README HISTORY COPYRIGHT
-contribs       := contrib/gbs2ogg.sh
+contribs       := contrib/gbs2ogg.sh contrib/gbsplay.bashcompletion
 examples       := examples/nightmode.gbs examples/gbsplayrc_sample
 
 mans           := gbsplay.1    gbsinfo.1    gbsplayrc.5
 mans_src       := gbsplay.in.1 gbsinfo.in.1 gbsplayrc.in.5
 
-objs_libgbspic := gbcpu.lo gbhw.lo gbs.lo cfgparser.lo crc32.lo
-objs_libgbs    := gbcpu.o  gbhw.o  gbs.o  cfgparser.o  crc32.o
+objs_libgbspic := gbcpu.lo gbhw.lo gbs.lo cfgparser.lo crc32.lo impulsegen.lo
+objs_libgbs    := gbcpu.o  gbhw.o  gbs.o  cfgparser.o  crc32.o  impulsegen.o
 objs_gbsplay   := gbsplay.o util.o plugout.o
 objs_gbsinfo   := gbsinfo.o
 objs_gbsxmms   := gbsxmms.lo
@@ -64,12 +84,30 @@
 ifeq ($(plugout_devdsp),yes)
 objs_gbsplay += plugout_devdsp.o
 endif
+ifeq ($(plugout_alsa),yes)
+objs_gbsplay += plugout_alsa.o
+GBSPLAYLDFLAGS += -lasound $(libaudio_flags)
+endif
 ifeq ($(plugout_nas),yes)
 objs_gbsplay += plugout_nas.o
 GBSPLAYLDFLAGS += -laudio $(libaudio_flags)
 endif
 ifeq ($(plugout_stdout),yes)
 objs_gbsplay += plugout_stdout.o
+endif
+ifeq ($(plugout_midi),yes)
+objs_gbsplay += plugout_midi.o
+endif
+
+# install contrib files?
+ifeq ($(build_contrib),yes)
+EXTRA_INSTALL += install-contrib
+EXTRA_UNINSTALL += uninstall-contrib
+endif
+
+# test built binary?
+ifeq ($(build_test),yes)
+TEST_TARGETS += test
 endif
 
 # Cygwin automatically adds .exe to binaries.
@@ -83,10 +121,38 @@
 
 ifeq ($(use_sharedlibgbs),yes)
 GBSLDFLAGS += -L. -lgbs
+objs += $(objs_libgbspic)
+ifeq ($(cygwin_build),yes)
+EXTRA_INSTALL += install-cyggbs-1.dll
+EXTRA_UNINSTALL += uninstall-cyggbs-1.dll
+
+install-cyggbs-1.dll:
+	install -d $(bindir)
+	install -d $(libdir)
+	install -m 644 cyggbs-1.dll $(bindir)/cyggbs-1.dll
+	install -m 644 libgbs.dll.a $(libdir)/libgbs.dll.a
+
+uninstall-cyggbs-1.dll:
+	rm -f $(bindir)/cyggbs-1.dll
+	rm -f $(libdir)/libgbs.dll.a
+	-rmdir -p $(libdir)
+
+
+cyggbs-1.dll: $(objs_libgbspic) libgbs.so.1.ver
+	$(CC) -fpic -shared -Wl,-O1 -Wl,-soname=$@ -Wl,--version-script,libgbs.so.1.ver -o $@ $(objs_libgbspic) $(EXTRA_LDFLAGS)
+
+libgbs.dll.a:
+	dlltool --input-def libgbs.def --dllname cyggbs-1.dll --output-lib libgbs.dll.a -k
+
+libgbs: cyggbs-1.dll libgbs.dll.a
+	touch libgbs
+
+libgbspic: cyggbs-1.dll libgbs.dll.a
+	touch libgbspic
+else
 EXTRA_INSTALL += install-libgbs.so.1
 EXTRA_UNINSTALL += uninstall-libgbs.so.1
 
-objs += $(objs_libgbspic)
 
 install-libgbs.so.1:
 	install -d $(libdir)
@@ -106,6 +172,7 @@
 
 libgbspic: libgbs.so.1
 	touch libgbspic
+endif
 else
 objs += $(objs_libgbs)
 objs_gbsplay += libgbs.a
@@ -133,7 +200,7 @@
 # include the rules for each subdir
 include $(shell find . -type f -name "subdir.mk")
 
-default: config.mk $(objs) $(dsts) $(mans) $(EXTRA_ALL) test
+default: config.mk $(objs) $(dsts) $(mans) $(EXTRA_ALL) $(TEST_TARGETS)
 
 # include the dependency files
 
@@ -161,19 +228,21 @@
 	install -d $(man1dir)
 	install -d $(man5dir)
 	install -d $(docdir)
-	install -d $(contribdir)
 	install -d $(exampledir)
 	install -m 755 $(gbsplaybin) $(gbsinfobin) $(bindir)
 	install -m 644 gbsplay.1 gbsinfo.1 $(man1dir)
 	install -m 644 gbsplayrc.5 $(man5dir)
 	install -m 644 $(docs) $(docdir)
-	install -m 644 $(contribs) $(contribdir)
 	install -m 644 $(examples) $(exampledir)
 	for i in $(mos); do \
 		base=`basename $$i`; \
 		install -d $(localedir)/$${base%.mo}/LC_MESSAGES; \
 		install -m 644 $$i $(localedir)/$${base%.mo}/LC_MESSAGES/gbsplay.mo; \
 	done
+
+install-contrib:
+	install -d $(contribdir)
+	install -m 644 $(contribs) $(contribdir)
 
 install-gbsxmms.so:
 	install -d $(xmmsdir)
@@ -188,8 +257,6 @@
 	-rmdir -p $(man1dir)
 	rm -f $(man5dir)/gbsplayrc.5 $(man5dir)/gbsplayrc.5	
 	-rmdir -p $(man5dir)
-	rm -rf $(contribdir)
-	-rmdir -p $(contribdir)
 	rm -rf $(exampledir)
 	-rmdir -p $(exampledir)
 	rm -rf $(docdir)
@@ -200,6 +267,10 @@
 		rm -f $(localedir)/$${base%.mo}/LC_MESSAGES/gbsplay.mo; \
 		rmdir -p $(localedir)/$${base%.mo}/LC_MESSAGES; \
 	done
+
+uninstall-contrib:
+	rm -rf $(contribdir)
+	-rmdir -p $(contribdir)
 
 uninstall-gbsxmms.so:
 	rm -f $(xmmsdir)/gbsxmms.so
@@ -230,7 +301,7 @@
 
 test: gbsplay
 	@MD5=`LD_LIBRARY_PATH=.:$$LD_LIBRARY_PATH ./gbsplay -E b -o stdout $(TESTOPTS) examples/nightmode.gbs 1 | md5sum | cut -f1 -d\ `; \
-	EXPECT="3e0b21573e742101581b503da3ddf2f5"; \
+	EXPECT="577ade576a9b99de27edff4236c8e303"; \
 	if [ "$$MD5" = "$$EXPECT" ]; then \
 		echo "Bigendian output ok"; \
 	else \
@@ -240,7 +311,7 @@
 		exit 1; \
 	fi
 	@MD5=`LD_LIBRARY_PATH=.:$$LD_LIBRARY_PATH ./gbsplay -E l -o stdout $(TESTOPTS) examples/nightmode.gbs 1 | md5sum | cut -f1 -d\ `; \
-	EXPECT="3e540a0bddc00cb1e0b7c4bf1a3708d7"; \
+	EXPECT="4423ba04ce18f5328986b5595991129c"; \
 	if [ "$$MD5" = "$$EXPECT" ]; then \
 		echo "Littleendian output ok"; \
 	else \
@@ -271,6 +342,7 @@
 	@$(CC) $(GBSCFLAGS) -fpic -c -o $@ $<
 .c.o:
 	@echo CC $< -o $@
+	@(test -x "`which $(SPLINT)`" && $(SPLINT) $(SPLINTFLAGS) $<) || true
 	@$(CC) $(GBSCFLAGS) -c -o $@ $<
 .c.i:
 	$(CC) -E $(GBSCFLAGS) -o $@ $<

## gbsplay 0.0.93

=== Makefile ===
--- 
+++ 
@@ -65,9 +65,10 @@
 GBSCFLAGS  += $(EXTRA_CFLAGS)
 GBSLDFLAGS += $(EXTRA_LDFLAGS)
 
-export CC GBSCFLAGS GBSLDFLAGS
+export CC HOSTCC BUILDCC GBSCFLAGS GBSLDFLAGS
 
 docs           := README HISTORY COPYRIGHT
+docs-dist      := INSTALL CODINGSTYLE TESTSUITE gbsformat.txt
 contribs       := contrib/gbs2ogg.sh contrib/gbsplay.bashcompletion
 examples       := examples/nightmode.gbs examples/gbsplayrc_sample
 
@@ -79,6 +80,9 @@
 objs_gbsplay   := gbsplay.o util.o plugout.o
 objs_gbsinfo   := gbsinfo.o
 objs_gbsxmms   := gbsxmms.lo
+objs_test_gbs  := test_gbs.o
+
+tests          := util.test
 
 # gbsplay output plugins
 ifeq ($(plugout_devdsp),yes)
@@ -97,6 +101,14 @@
 endif
 ifeq ($(plugout_midi),yes)
 objs_gbsplay += plugout_midi.o
+endif
+ifeq ($(plugout_pulse),yes)
+objs_gbsplay += plugout_pulse.o
+GBSPLAYLDFLAGS += -lpulse-simple -lpulse
+endif
+ifeq ($(plugout_dsound),yes)
+objs_gbsplay += plugout_dsound.o
+GBSPLAYLDFLAGS += -ldsound $(libdsound_flags)
 endif
 
 # install contrib files?
@@ -114,9 +126,13 @@
 # We should notice that or we can't rm the files later!
 gbsplaybin     := gbsplay
 gbsinfobin     := gbsinfo
+test_gbsbin    := test_gbs
+test_bin       := test
 ifeq ($(cygwin_build),yes)
 gbsplaybin     :=$(gbsplaybin).exe
 gbsinfobin     :=$(gbsinfobin).exe
+test_gbsbin    :=$(test_gbsbin).exe
+test_bin       :=$(test).exe
 endif
 
 ifeq ($(use_sharedlibgbs),yes)
@@ -164,7 +180,7 @@
 
 
 libgbs.so.1: $(objs_libgbspic) libgbs.so.1.ver
-	$(CC) -fpic -shared -Wl,-O1 -Wl,-soname=$@ -Wl,--version-script,$@.ver -o $@ $(objs_libgbspic)
+	$(BUILDCC) -fpic -shared -Wl,-O1 -Wl,-soname=$@ -Wl,--version-script,$@.ver -o $@ $(objs_libgbspic)
 	ln -fs $@ libgbs.so
 
 libgbs: libgbs.so.1
@@ -177,6 +193,7 @@
 objs += $(objs_libgbs)
 objs_gbsplay += libgbs.a
 objs_gbsinfo += libgbs.a
+objs_test_gbs += libgbs.a
 ifeq ($(build_xmmsplugin),yes)
 objs += $(objs_libgbspic)
 objs_gbsxmms += libgbspic.a
@@ -220,6 +237,7 @@
 	rm -f libgbs libgbspic
 	rm -f $(mans)
 	rm -f $(gbsplaybin) $(gbsinfobin)
+	rm -f $(test_gbsbin) $(test_bin)
 
 install: all install-default $(EXTRA_INSTALL)
 
@@ -255,7 +273,7 @@
 	-rmdir -p $(bindir)
 	rm -f $(man1dir)/gbsplay.1 $(man1dir)/gbsinfo.1
 	-rmdir -p $(man1dir)
-	rm -f $(man5dir)/gbsplayrc.5 $(man5dir)/gbsplayrc.5	
+	rm -f $(man5dir)/gbsplayrc.5
 	-rmdir -p $(man5dir)
 	rm -rf $(exampledir)
 	-rmdir -p $(exampledir)
@@ -284,9 +302,9 @@
 	install -m 644 Makefile ./$(DISTDIR)/
 	install -m 644 *.c ./$(DISTDIR)/
 	install -m 644 *.h ./$(DISTDIR)/
-	install -m 644 *.ver ./$(DISTDIR)/
+	install -m 644 *.ver *.def ./$(DISTDIR)/
 	install -m 644 $(mans_src) ./$(DISTDIR)/
-	install -m 644 $(docs) INSTALL CODINGSTYLE ./$(DISTDIR)/
+	install -m 644 $(docs) $(docs-dist) ./$(DISTDIR)/
 	install -d ./$(DISTDIR)/examples
 	install -m 644 $(examples) ./$(DISTDIR)/examples
 	install -d ./$(DISTDIR)/contrib
@@ -294,14 +312,16 @@
 	install -d ./$(DISTDIR)/po
 	install -m 644 po/*.po ./$(DISTDIR)/po
 	install -m 644 po/subdir.mk ./$(DISTDIR)/po
+	install -m 644 .gitignore ./$(DISTDIR)/
 	tar -cvzf ../$(DISTDIR).tar.gz $(DISTDIR)/ 
 	rm -rf ./$(DISTDIR)
 
 TESTOPTS := -r 44100 -t 30 -f 0 -g 0 -T 0
 
-test: gbsplay
-	@MD5=`LD_LIBRARY_PATH=.:$$LD_LIBRARY_PATH ./gbsplay -E b -o stdout $(TESTOPTS) examples/nightmode.gbs 1 | md5sum | cut -f1 -d\ `; \
-	EXPECT="577ade576a9b99de27edff4236c8e303"; \
+test: gbsplay $(tests) test_gbs
+	@echo Verifying output correctness for examples/nightmode.gbs:
+	@MD5=`LD_LIBRARY_PATH=.:$$LD_LIBRARY_PATH ./gbsplay -c examples/gbsplayrc_sample -E b -o stdout $(TESTOPTS) examples/nightmode.gbs 1 < /dev/null | md5sum | cut -f1 -d\ `; \
+	EXPECT="5269fdada196a6b67d947428ea3ca934"; \
 	if [ "$$MD5" = "$$EXPECT" ]; then \
 		echo "Bigendian output ok"; \
 	else \
@@ -310,8 +330,8 @@
 		echo "  Got:      $$MD5" ; \
 		exit 1; \
 	fi
-	@MD5=`LD_LIBRARY_PATH=.:$$LD_LIBRARY_PATH ./gbsplay -E l -o stdout $(TESTOPTS) examples/nightmode.gbs 1 | md5sum | cut -f1 -d\ `; \
-	EXPECT="4423ba04ce18f5328986b5595991129c"; \
+	@MD5=`LD_LIBRARY_PATH=.:$$LD_LIBRARY_PATH ./gbsplay -c examples/gbsplayrc_sample -E l -o stdout $(TESTOPTS) examples/nightmode.gbs 1 < /dev/null | md5sum | cut -f1 -d\ `; \
+	EXPECT="3c005a70135621d8eb3e0dc20982eba8"; \
 	if [ "$$MD5" = "$$EXPECT" ]; then \
 		echo "Littleendian output ok"; \
 	else \
@@ -326,12 +346,14 @@
 libgbs.a: $(objs_libgbs)
 	$(AR) r $@ $+
 gbsinfo: $(objs_gbsinfo) libgbs
-	$(CC) -o $(gbsinfobin) $(objs_gbsinfo) $(GBSLDFLAGS)
+	$(BUILDCC) -o $(gbsinfobin) $(objs_gbsinfo) $(GBSLDFLAGS)
 gbsplay: $(objs_gbsplay) libgbs
-	$(CC) -o $(gbsplaybin) $(objs_gbsplay) $(GBSLDFLAGS) $(GBSPLAYLDFLAGS) -lm
+	$(BUILDCC) -o $(gbsplaybin) $(objs_gbsplay) $(GBSLDFLAGS) $(GBSPLAYLDFLAGS) -lm
+test_gbs: $(objs_test_gbs) libgbs
+	$(BUILDCC) -o $(test_gbsbin) $(objs_test_gbs) $(GBSLDFLAGS)
 
 gbsxmms.so: $(objs_gbsxmms) libgbspic gbsxmms.so.ver
-	$(CC) -shared -fpic -Wl,--version-script,$@.ver -o $@ $(objs_gbsxmms) $(GBSLDFLAGS) $(PTHREAD)
+	$(BUILDCC) -shared -fpic -Wl,--version-script,$@.ver -o $@ $(objs_gbsxmms) $(GBSLDFLAGS) $(PTHREAD)
 
 # rules for suffixes
 
@@ -339,20 +361,27 @@
 
 .c.lo:
 	@echo CC $< -o $@
-	@$(CC) $(GBSCFLAGS) -fpic -c -o $@ $<
+	@$(BUILDCC) $(GBSCFLAGS) -fpic -c -o $@ $<
 .c.o:
 	@echo CC $< -o $@
 	@(test -x "`which $(SPLINT)`" && $(SPLINT) $(SPLINTFLAGS) $<) || true
-	@$(CC) $(GBSCFLAGS) -c -o $@ $<
+	@$(BUILDCC) $(GBSCFLAGS) -c -o $@ $<
+
 .c.i:
-	$(CC) -E $(GBSCFLAGS) -o $@ $<
+	$(BUILDCC) -E $(GBSCFLAGS) -o $@ $<
 .c.s:
-	$(CC) -S $(GBSCFLAGS) -fverbose-asm -o $@ $<
+	$(BUILDCC) -S $(GBSCFLAGS) -fverbose-asm -o $@ $<
 
 # rules for generated files
 
 config.mk: configure
 	./configure
+
+%.test: %.c
+	@echo -n "TEST $< "
+	@$(HOSTCC) -DENABLE_TEST=1 -o $(test_bin) $<
+	@./$(test_bin)
+	@rm ./$(test_bin)
 
 %.d: %.c config.mk
 	@echo DEP $< -o $@

=== debian/changelog ===
gbsplay (0.0.93-3) unstable; urgency=medium

  * Bump standards version to 4.1.3.
  * Bump debhelper version to 11.
  * debian/source/format: added.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Fri, 05 Jan 2018 14:48:03 +0100

gbsplay (0.0.93-2) unstable; urgency=medium

  * Update my name.
  * Apply ESTRPIPE patch to fix a bug. (Closes: #815490)
  * Bump standards version to 3.9.8.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Mon, 23 Jan 2017 15:49:28 +0100

gbsplay (0.0.93-1) unstable; urgency=medium

  * New upstream release (Closes: #794618).
  * Update debian/copyright:
    - List original copyright instead of boilerplate GPL-2 licence text.
    - Link to /usr/share/common-licenses/GPL-1 as unversioned GPL means
      "choose any" (v1 or later).  This fixes the lintian warning
      copyright-refers-to-versionless-license-file
  * Update debian/rules to fix lintian warnings:
    - hardening-no-relro

 -- Christian Garbs <debian@cgarbs.de>  Sun, 30 Aug 2015 20:33:29 +0200

gbsplay (0.0.92-1) unstable; urgency=medium

  * New upstream release (Closes: #715944, #777862).
  * Ship contrib/gbs2ogg.sh again, license is now provided.
  * Update debian/rules to fix lintian warnings:
    - debian-rules-missing-recommended-target
    - dh-clean-k-is-deprecated
    - description-synopsis-starts-with-article
    - ancient-standards-version (no changes)
  * Update Debian compat version to 9.
  * Add debian/watch.

 -- Christian Garbs <debian@cgarbs.de>  Sun, 02 Aug 2015 14:55:37 +0200

gbsplay (0.0.91-1) unstable; urgency=low

  * New upstream version.

 -- Gürkan Sengün <gurkan@phys.ethz.ch>  Tue, 19 Aug 2008 17:30:19 +0200

gbsplay (0.0.9+dfsg1-1) unstable; urgency=low

  * New upstream version.
  * Updated my email address.
  * Updated standards version.

 -- Gürkan Sengün <gurkan@phys.ethz.ch>  Tue, 08 Jul 2008 12:55:56 +0200

gbsplay (0.0.8+dfsg1-3) unstable; urgency=low

  * Remove build-depends on xmms-dev and don't build the xmms
    plugin anymore. (Closes: #456741)
  * Bump standards version.

 -- Gürkan Sengün <gurkan@linuks.mine.nu>  Sat, 12 Jan 2008 12:57:40 +0100

gbsplay (0.0.8+dfsg1-2) unstable; urgency=low

  * Turned off buggy endian checks. (Closes: #418726)

 -- Gürkan Sengün <gurkan@linuks.mine.nu>  Wed, 09 May 2007 10:27:07 +0200

gbsplay (0.0.8+dfsg1-1) unstable; urgency=low

  * Initial release. (Closes: #411445)
  * Rebuilt the tarball (non-free contrib script).

 -- Gürkan Sengün <gurkan@linuks.mine.nu>  Mon, 19 Feb 2007 08:49:34 +0100

=== debian/control ===
Source: gbsplay
Section: sound
Priority: optional
Maintainer: Gürkan Myczko <gurkan@phys.ethz.ch>
Uploaders: Christian Garbs <debian@cgarbs.de>
Standards-Version: 4.1.3
Build-Depends: debhelper (>= 11), gettext, libaudio-dev, libpulse-dev, libasound2-dev
Homepage: https://github.com/mmitch/gbsplay

Package: gbsplay
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: vorbis-tools
Description: Gameboy sound player
 This program emulates the sound hardware of the Nintendo Gameboy.  It
 is able to play the sounds from a Gameboy module dump (.GBS format).
 Also included is the gbsinfo tool which displays information about
 a .GBS file.

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

config.status: configure
	dh_testdir
	./configure --host=$(DEB_HOST_GNU_TYPE) --prefix=/usr --bindir=\$${prefix}/bin --docdir=\$${prefix}/share/doc/gbsplay --mandir=\$${prefix}/share/man --enable-nas --enable-midi --enable-devdsp --enable-stdout --enable-alsa --enable-pulse --without-xmmsplugin CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)"

build: build-arch build-indep

build-arch: build-stamp

build-indep: build-stamp

build-stamp:  config.status
	dh_testdir
	$(MAKE) V=1
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	[ ! -f Makefile ] || $(MAKE) distclean
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	$(MAKE) prefix=$(CURDIR)/debian/gbsplay/usr contribdir=$(CURDIR)/debian/gbsplay/usr/share/doc/gbsplay/contrib exampledir=$(CURDIR)/debian/gbsplay/usr/share/doc/gbsplay/examples localedir=$(CURDIR)/debian/gbsplay/usr/share/locale install
	rm -f $(CURDIR)/debian/gbsplay/usr/share/doc/gbsplay/COPYRIGHT $(CURDIR)/debian/gbsplay/usr/share/doc/gbsplay/README
	mv $(CURDIR)/debian/gbsplay/usr/share/doc/gbsplay/HISTORY $(CURDIR)/debian/gbsplay/usr/share/doc/gbsplay/changelog

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/gbsplay-$1\.tar\.gz/ \
  https://github.com/mmitch/gbsplay/tags .*/(\d\S*)\.tar\.gz

## gbsplay 0.0.94

=== Makefile ===
--- 
+++ 
@@ -1,8 +1,20 @@
 .PHONY: all default distclean clean install dist
 
+ifeq ("$(origin V)", "command line")
+  VERBOSE = $(V)
+endif
+ifndef VERBOSE
+  VERBOSE = 0
+endif
+ifeq ($(VERBOSE),1)
+  Q =
+else
+  Q = @
+endif
+
 all: default
 
-noincludes  := $(patsubst clean,yes,$(patsubst distclean,yes,$(MAKECMDGOALS)))
+noincludes  := $(patsubst distclean,yes,$(MAKECMDGOALS))
 
 prefix      := /usr/local
 exec_prefix := $(prefix)
@@ -12,6 +24,8 @@
 mandir      := $(prefix)/man
 docdir      := $(prefix)/share/doc/gbsplay
 localedir   := $(prefix)/share/locale
+mimedir     := $(prefix)/share/mime
+appdir      := $(prefix)/share/applications
 
 SPLINT := splint
 
@@ -35,9 +49,6 @@
 	-predboolothers \
 	-shiftnegative \
 	-shiftimplementation
-GBSCFLAGS  := -Wall -fsigned-char -D_FORTIFY_SOURCE=2
-GBSLDFLAGS := -Wl,-O1 -lm
-GBSPLAYLDFLAGS :=
 
 ifneq ($(noincludes),yes)
 -include config.mk
@@ -52,6 +63,8 @@
 mandir      := $(DESTDIR)$(mandir)
 docdir      := $(DESTDIR)$(docdir)
 localedir   := $(DESTDIR)$(localedir)
+mimedir     := $(DESTDIR)$(mimedir)
+appdir      := $(DESTDIR)$(appdir)
 
 xmmsdir     := $(DESTDIR)$(XMMSPREFIX)$(XMMS_INPUT_PLUGIN_DIR)
 
@@ -62,27 +75,30 @@
 
 DISTDIR := gbsplay-$(VERSION)
 
-GBSCFLAGS  += $(EXTRA_CFLAGS)
-GBSLDFLAGS += $(EXTRA_LDFLAGS)
-
-export CC HOSTCC BUILDCC GBSCFLAGS GBSLDFLAGS
-
-docs           := README HISTORY COPYRIGHT
-docs-dist      := INSTALL CODINGSTYLE TESTSUITE gbsformat.txt
-contribs       := contrib/gbs2ogg.sh contrib/gbsplay.bashcompletion
-examples       := examples/nightmode.gbs examples/gbsplayrc_sample
-
-mans           := gbsplay.1    gbsinfo.1    gbsplayrc.5
-mans_src       := gbsplay.in.1 gbsinfo.in.1 gbsplayrc.in.5
-
-objs_libgbspic := gbcpu.lo gbhw.lo gbs.lo cfgparser.lo crc32.lo impulsegen.lo
-objs_libgbs    := gbcpu.o  gbhw.o  gbs.o  cfgparser.o  crc32.o  impulsegen.o
-objs_gbsplay   := gbsplay.o util.o plugout.o
-objs_gbsinfo   := gbsinfo.o
-objs_gbsxmms   := gbsxmms.lo
-objs_test_gbs  := test_gbs.o
-
-tests          := util.test
+GBSCFLAGS  := $(EXTRA_CFLAGS)
+GBSLDFLAGS := $(EXTRA_LDFLAGS)
+# Additional ldflags for the gbsplay executable
+GBSPLAYLDFLAGS :=
+
+export Q VERBOSE CC HOSTCC BUILDCC GBSCFLAGS GBSLDFLAGS
+
+docs               := README HISTORY COPYRIGHT
+docs-dist          := INSTALL CODINGSTYLE TESTSUITE gbsformat.txt
+contribs           := contrib/gbs2ogg.sh contrib/gbsplay.bashcompletion
+examples           := examples/nightmode.gbs examples/gbsplayrc_sample
+
+mans               := man/gbsplay.1    man/gbsinfo.1    man/gbsplayrc.5
+mans_src           := man/gbsplay.in.1 man/gbsinfo.in.1 man/gbsplayrc.in.5
+
+objs_libgbspic     := gbcpu.lo gbhw.lo gbs.lo cfgparser.lo crc32.lo
+objs_libgbs        := gbcpu.o  gbhw.o  gbs.o  cfgparser.o  crc32.o
+objs_gbsplay       := gbsplay.o util.o plugout.o
+objs_gbsinfo       := gbsinfo.o
+objs_gbsxmms       := gbsxmms.lo
+objs_test_gbs      := test_gbs.o
+objs_gen_impulse_h := gen_impulse_h.ho impulsegen.ho
+
+tests              := util.test impulsegen.test
 
 # gbsplay output plugins
 ifeq ($(plugout_devdsp),yes)
@@ -102,6 +118,9 @@
 ifeq ($(plugout_midi),yes)
 objs_gbsplay += plugout_midi.o
 endif
+ifeq ($(plugout_altmidi),yes)
+objs_gbsplay += plugout_altmidi.o
+endif
 ifeq ($(plugout_pulse),yes)
 objs_gbsplay += plugout_pulse.o
 GBSPLAYLDFLAGS += -lpulse-simple -lpulse
@@ -109,6 +128,9 @@
 ifeq ($(plugout_dsound),yes)
 objs_gbsplay += plugout_dsound.o
 GBSPLAYLDFLAGS += -ldsound $(libdsound_flags)
+endif
+ifeq ($(plugout_iodumper),yes)
+objs_gbsplay += plugout_iodumper.o
 endif
 
 # install contrib files?
@@ -124,20 +146,26 @@
 
 # Cygwin automatically adds .exe to binaries.
 # We should notice that or we can't rm the files later!
-gbsplaybin     := gbsplay
-gbsinfobin     := gbsinfo
-test_gbsbin    := test_gbs
-test_bin       := test
 ifeq ($(cygwin_build),yes)
-gbsplaybin     :=$(gbsplaybin).exe
-gbsinfobin     :=$(gbsinfobin).exe
-test_gbsbin    :=$(test_gbsbin).exe
-test_bin       :=$(test).exe
-endif
+binsuffix         := .exe
+else
+binsuffix         :=
+endif
+gbsplaybin        := gbsplay$(binsuffix)
+gbsinfobin        := gbsinfo$(binsuffix)
+test_gbsbin       := test_gbs$(binsuffix)
+gen_impulse_h_bin := gen_impulse_h$(binsuffix)
 
 ifeq ($(use_sharedlibgbs),yes)
 GBSLDFLAGS += -L. -lgbs
 objs += $(objs_libgbspic)
+
+libgbs.so.1.ver: libgbs_whitelist.txt gen_linkercfg.sh
+	./gen_linkercfg.sh libgbs_whitelist.txt $@ ver
+
+libgbs.def: libgbs_whitelist.txt gen_linkercfg.sh
+	./gen_linkercfg.sh libgbs_whitelist.txt $@ def
+
 ifeq ($(cygwin_build),yes)
 EXTRA_INSTALL += install-cyggbs-1.dll
 EXTRA_UNINSTALL += uninstall-cyggbs-1.dll
@@ -153,11 +181,10 @@
 	rm -f $(libdir)/libgbs.dll.a
 	-rmdir -p $(libdir)
 
-
 cyggbs-1.dll: $(objs_libgbspic) libgbs.so.1.ver
-	$(CC) -fpic -shared -Wl,-O1 -Wl,-soname=$@ -Wl,--version-script,libgbs.so.1.ver -o $@ $(objs_libgbspic) $(EXTRA_LDFLAGS)
-
-libgbs.dll.a:
+	$(CC) -fpic -shared -Wl,-soname=$@ -Wl,--version-script,libgbs.so.1.ver -o $@ $(objs_libgbspic) $(EXTRA_LDFLAGS)
+
+libgbs.dll.a: libgbs.def
 	dlltool --input-def libgbs.def --dllname cyggbs-1.dll --output-lib libgbs.dll.a -k
 
 libgbs: cyggbs-1.dll libgbs.dll.a
@@ -180,7 +207,7 @@
 
 
 libgbs.so.1: $(objs_libgbspic) libgbs.so.1.ver
-	$(BUILDCC) -fpic -shared -Wl,-O1 -Wl,-soname=$@ -Wl,--version-script,$@.ver -o $@ $(objs_libgbspic)
+	$(BUILDCC) -fpic -shared -Wl,-soname=$@ -Wl,--version-script,$@.ver -o $@ $(objs_libgbspic) -lm
 	ln -fs $@ libgbs.so
 
 libgbs: libgbs.so.1
@@ -190,6 +217,7 @@
 	touch libgbspic
 endif
 else
+GBSLDFLAGS += -lm
 objs += $(objs_libgbs)
 objs_gbsplay += libgbs.a
 objs_gbsinfo += libgbs.a
@@ -232,12 +260,13 @@
 	rm -f ./config.mk ./config.h ./config.err ./config.sed
 
 clean:
-	find . -regex ".*\.\([aos]\|lo\|mo\|pot\|so\(\.[0-9]\)?\)" -exec rm -f "{}" \;
+	find . -regex ".*\.\([aos]\|ho\|lo\|mo\|pot\|test\(\.exe\)?\|so\(\.[0-9]\)?\)" -exec rm -f "{}" \;
 	find . -name "*~" -exec rm -f "{}" \;
-	rm -f libgbs libgbspic
+	rm -f libgbs libgbspic libgbs.def libgbs.so.1.ver
 	rm -f $(mans)
 	rm -f $(gbsplaybin) $(gbsinfobin)
-	rm -f $(test_gbsbin) $(test_bin)
+	rm -f $(test_gbsbin)
+	rm -f $(gen_impulse_h_bin) impulse.h
 
 install: all install-default $(EXTRA_INSTALL)
 
@@ -247,9 +276,15 @@
 	install -d $(man5dir)
 	install -d $(docdir)
 	install -d $(exampledir)
+	install -d $(mimedir)/packages
+	install -d $(appdir)
 	install -m 755 $(gbsplaybin) $(gbsinfobin) $(bindir)
-	install -m 644 gbsplay.1 gbsinfo.1 $(man1dir)
-	install -m 644 gbsplayrc.5 $(man5dir)
+	install -m 644 man/gbsplay.1 man/gbsinfo.1 $(man1dir)
+	install -m 644 man/gbsplayrc.5 $(man5dir)
+	install -m 644 mime/gbsplay.xml $(mimedir)/packages
+	-update-mime-database $(mimedir)
+	install -m 644 desktop/gbsplay.desktop $(appdir)
+	-update-desktop-database $(appdir)
 	install -m 644 $(docs) $(docdir)
 	install -m 644 $(examples) $(exampledir)
 	for i in $(mos); do \
@@ -275,6 +310,12 @@
 	-rmdir -p $(man1dir)
 	rm -f $(man5dir)/gbsplayrc.5
 	-rmdir -p $(man5dir)
+	rm -f $(mimedir)/packages/gbsplay.xml
+	-update-mime-database $(mimedir)
+	-rmdir -p $(mimedir)/packages
+	rm -f $(appdir)/gbsplay.desktop
+	-update-desktop-database $(appdir)
+	-rmdir -p $(appdir)
 	rm -rf $(exampledir)
 	-rmdir -p $(exampledir)
 	rm -rf $(docdir)
@@ -302,8 +343,9 @@
 	install -m 644 Makefile ./$(DISTDIR)/
 	install -m 644 *.c ./$(DISTDIR)/
 	install -m 644 *.h ./$(DISTDIR)/
-	install -m 644 *.ver *.def ./$(DISTDIR)/
-	install -m 644 $(mans_src) ./$(DISTDIR)/
+	install -m 644 *.ver ./$(DISTDIR)/
+	install -d ./$(DISTDIR)/man
+	install -m 644 $(mans_src) ./$(DISTDIR)/man
 	install -m 644 $(docs) $(docs-dist) ./$(DISTDIR)/
 	install -d ./$(DISTDIR)/examples
 	install -m 644 $(examples) ./$(DISTDIR)/examples
@@ -313,15 +355,19 @@
 	install -m 644 po/*.po ./$(DISTDIR)/po
 	install -m 644 po/subdir.mk ./$(DISTDIR)/po
 	install -m 644 .gitignore ./$(DISTDIR)/
+	install -d ./$(DISTDIR)/mime
+	install -m 644 mime/* ./$(DISTDIR)/mime
+	install -d ./$(DISTDIR)/desktop
+	install -m 644 desktop/* ./$(DISTDIR)/desktop
 	tar -cvzf ../$(DISTDIR).tar.gz $(DISTDIR)/ 
 	rm -rf ./$(DISTDIR)
 
-TESTOPTS := -r 44100 -t 30 -f 0 -g 0 -T 0
+TESTOPTS := -r 44100 -t 30 -f 0 -g 0 -T 0 -H off
 
 test: gbsplay $(tests) test_gbs
 	@echo Verifying output correctness for examples/nightmode.gbs:
-	@MD5=`LD_LIBRARY_PATH=.:$$LD_LIBRARY_PATH ./gbsplay -c examples/gbsplayrc_sample -E b -o stdout $(TESTOPTS) examples/nightmode.gbs 1 < /dev/null | md5sum | cut -f1 -d\ `; \
-	EXPECT="5269fdada196a6b67d947428ea3ca934"; \
+	$(Q)MD5=`LD_LIBRARY_PATH=.:$$LD_LIBRARY_PATH ./gbsplay -c examples/gbsplayrc_sample -E b -o stdout $(TESTOPTS) examples/nightmode.gbs 1 < /dev/null | (md5sum || md5 -r) | cut -f1 -d\ `; \
+	EXPECT="a6f920f9a9ac2bfbd0c7e22bb740db1c"; \
 	if [ "$$MD5" = "$$EXPECT" ]; then \
 		echo "Bigendian output ok"; \
 	else \
@@ -330,8 +376,8 @@
 		echo "  Got:      $$MD5" ; \
 		exit 1; \
 	fi
-	@MD5=`LD_LIBRARY_PATH=.:$$LD_LIBRARY_PATH ./gbsplay -c examples/gbsplayrc_sample -E l -o stdout $(TESTOPTS) examples/nightmode.gbs 1 < /dev/null | md5sum | cut -f1 -d\ `; \
-	EXPECT="3c005a70135621d8eb3e0dc20982eba8"; \
+	$(Q)MD5=`LD_LIBRARY_PATH=.:$$LD_LIBRARY_PATH ./gbsplay -c examples/gbsplayrc_sample -E l -o stdout $(TESTOPTS) examples/nightmode.gbs 1 < /dev/null | (md5sum || md5 -r) | cut -f1 -d\ `; \
+	EXPECT="c82104c3a25fe794df1496d66d9cf24c"; \
 	if [ "$$MD5" = "$$EXPECT" ]; then \
 		echo "Littleendian output ok"; \
 	else \
@@ -340,6 +386,13 @@
 		echo "  Got:      $$MD5" ; \
 		exit 1; \
 	fi
+
+$(gen_impulse_h_bin): $(objs_gen_impulse_h)
+	$(HOSTCC) -o $(gen_impulse_h_bin) $(objs_gen_impulse_h) -lm
+impulse.h: $(gen_impulse_h_bin)
+	$(Q)./$(gen_impulse_h_bin) > $@
+gbhw.o: impulse.h
+gbhw.lo: impulse.h
 
 libgbspic.a: $(objs_libgbspic)
 	$(AR) r $@ $+
@@ -357,15 +410,18 @@
 
 # rules for suffixes
 
-.SUFFIXES: .i .s .lo
+.SUFFIXES: .i .s .lo .ho
 
 .c.lo:
 	@echo CC $< -o $@
-	@$(BUILDCC) $(GBSCFLAGS) -fpic -c -o $@ $<
+	$(Q)$(BUILDCC) $(GBSCFLAGS) -fpic -c -o $@ $<
 .c.o:
 	@echo CC $< -o $@
-	@(test -x "`which $(SPLINT)`" && $(SPLINT) $(SPLINTFLAGS) $<) || true
-	@$(BUILDCC) $(GBSCFLAGS) -c -o $@ $<
+	$(Q)(test -x "`which $(SPLINT)`" && $(SPLINT) $(SPLINTFLAGS) $<) || true
+	$(Q)$(BUILDCC) $(GBSCFLAGS) -fpie -c -o $@ $<
+.c.ho:
+	@echo HOSTCC $< -o $@
+	$(Q)$(HOSTCC) $(GBSCFLAGS) -fpie -c -o $@ $<
 
 .c.i:
 	$(BUILDCC) -E $(GBSCFLAGS) -o $@ $<
@@ -378,17 +434,12 @@
 	./configure
 
 %.test: %.c
-	@echo -n "TEST $< "
-	@$(HOSTCC) -DENABLE_TEST=1 -o $(test_bin) $<
-	@./$(test_bin)
-	@rm ./$(test_bin)
+	@echo TEST $<
+	$(Q)$(HOSTCC) -DENABLE_TEST=1 -o $@$(binsuffix) $< -lm
+	$(Q)./$@$(binsuffix)
+	$(Q)rm ./$@$(binsuffix)
 
 %.d: %.c config.mk
 	@echo DEP $< -o $@
-	@./depend.sh $< config.mk > $@ || rm -f $@
-
-%.1: %.in.1
-	sed -f config.sed $< > $@
-
-%.5: %.in.5
-	sed -f config.sed $< > $@
+	$(Q)./depend.sh $< config.mk > $@ || rm -f $@
+

=== debian/changelog ===
gbsplay (0.0.94-2) unstable; urgency=medium

  * Disable tests due failure, reported upstream.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Wed, 20 Jan 2021 05:11:04 +0100

gbsplay (0.0.94-1) unstable; urgency=medium

  * New upstream version.
  * debian/gbsplay.desktop: Added.
  * Bump standards version to 4.5.0.
  * Bump debhelper version to 13, drop d/compat.
  * d/upstream/metadata: added.
  * d/control: added Rules-Requires-Root.
  * d/rules: modernized.
  * d/copyright: modernized.

 -- Gürkan Myczko <gurkan@phys.ethz.ch>  Fri, 03 Jul 2020 22:24:10 +0200

=== debian/control ===
--- 
+++ 
@@ -3,8 +3,9 @@
 Priority: optional
 Maintainer: Gürkan Myczko <gurkan@phys.ethz.ch>
 Uploaders: Christian Garbs <debian@cgarbs.de>
-Standards-Version: 4.1.3
-Build-Depends: debhelper (>= 11), gettext, libaudio-dev, libpulse-dev, libasound2-dev
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
+Build-Depends: debhelper-compat (= 13), gettext, libaudio-dev, libpulse-dev, libasound2-dev
 Homepage: https://github.com/mmitch/gbsplay
 
 Package: gbsplay

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -W

override_dh_auto_configure:
	./configure \
	--prefix=/usr \
	--exec-prefix=/usr \
	--mandir=\$${prefix}/share/man \
	--sysconfdir=/etc \
	--datadir=\$${prefix}/share/gbsplay \
	--bindir=\$${prefix}/bin \
	--infodir=\$${prefix}/share/info \
	--enable-nas --enable-midi --enable-devdsp --enable-stdout --enable-alsa --enable-pulse --without-xmmsplugin \
	CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)"

override_dh_auto_install:
	dh_auto_install
	-rm -r debian/gbsplay/usr/share/mime/aliases debian/gbsplay/usr/share/mime/generic-icons debian/gbsplay/usr/share/mime/globs debian/gbsplay/usr/share/mime/globs2 debian/gbsplay/usr/share/mime/icons debian/gbsplay/usr/share/mime/magic debian/gbsplay/usr/share/mime/mime.cache debian/gbsplay/usr/share/mime/subclasses debian/gbsplay/usr/share/mime/treemagic debian/gbsplay/usr/share/mime/types debian/gbsplay/usr/share/mime/version debian/gbsplay/usr/share/mime/XMLnamespaces debian/gbsplay/usr/share/mime/audio debian/gbsplay/usr/share/applications/*.cache

override_dh_auto_test:
	@echo SKIPPING TESTS, SEE https://github.com/mmitch/gbsplay/issues/62

%:
	dh $@ --no-parallel
